#include "memory.h"

#include <stdlib.h>


/* Initialise the memory pool with an optional 'limit' in pages. */

Memory::Memory(offset_t region_size)
: _region_size(region_size)
{
}

/* Allocate a block of the given 'size'. */

Region *Memory::allocate(offset_t size)
{
    /* Attempt to allocate aligned memory. */

    void *current;

    /* Make the size appropriate for the invocation. */

    size = round_multiple(size, PAGE_SIZE);

    if (posix_memalign(&current, size, size))
        return NULL;

    return new Region((offset_t) current, (offset_t) current + size);
}

// vim: tabstop=4 expandtab shiftwidth=4
